SystemOrganization addCategory: #'Coral-Examples-Esug2011'!

Object subclass: #Ansi
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Coral-Examples-Esug2011'!

!Ansi class methodsFor: 'as yet unclassified' stamp: 'DamienPollet 8/12/2011 21:57'!
sgr: sgrParameterString
	^ (String with: Character escape with: $[) ,
		sgrParameterString ,
		'm'! !

!Ansi class methodsFor: 'as yet unclassified' stamp: 'DamienPollet 8/12/2011 21:57'!
sgr: codes sgr: moreCodes
	^ (self sgr: codes) , (self sgr: moreCodes)! !

!Ansi class methodsFor: 'as yet unclassified' stamp: 'DamienPollet 8/12/2011 21:58'!
sgrReset
	^ self sgr: '0'! !

Object subclass: #CoralEsug2011Talk
	instanceVariableNames: 'colorizeMap'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Coral-Examples-Esug2011'!

!CoralEsug2011Talk class methodsFor: 'as yet unclassified' stamp: 'DamienPollet 8/12/2011 21:56'!
colorizeMapSolarized
	^ {
		$Y -> (Ansi sgr: '38;5;3' sgr: '48;5;3').
		$O -> (Ansi sgr: '38;5;9' sgr: '48;5;9').
		$R -> (Ansi sgr: '38;5;1' sgr: '48;5;1').
		$M -> (Ansi sgr: '38;5;5' sgr: '48;5;5').
		$P -> (Ansi sgr: '38;5;13' sgr: '48;5;13').
		$B -> (Ansi sgr: '38;5;4' sgr: '48;5;4').
		$C -> (Ansi sgr: '38;5;6' sgr: '48;5;6').
		$G -> (Ansi sgr: '38;5;2' sgr: '48;5;2').
	}! !

!CoralEsug2011Talk class methodsFor: 'as yet unclassified' stamp: 'DamienPollet 8/12/2011 21:50'!
solarized
	^ self new colorizeMap: self colorizeMapSolarized! !

!CoralEsug2011Talk methodsFor: 'utilities' stamp: 'DamienPollet 8/12/2011 21:58'!
ansiColorize: aString colorMap: colorMap
	"Surround contiguous sequences of some characters in aString with ANSI color codes.
	colorMap is an Array of Associations mapping characters to the desired ANSI color number"
	
	^ colorMap inject: aString into: [ :img :map |
		| pattern |
		pattern := String with: map key with: $+.
		(RxMatcher forString: pattern)
			copy: img
			translatingMatchesUsing: [ :substring | map value , substring , Ansi sgrReset ] ]! !

!CoralEsug2011Talk methodsFor: 'utilities' stamp: 'DamienPollet 8/12/2011 21:50'!
colorize: aString
	^ self ansiColorize: aString colorMap: colorizeMap! !

!CoralEsug2011Talk methodsFor: 'initialization' stamp: 'DamienPollet 8/12/2011 21:49'!
colorizeMap: aMap
	colorizeMap := aMap! !

!CoralEsug2011Talk methodsFor: 'data' stamp: 'DamienPollet 8/12/2011 21:59'!
edinburghLogo
	^ self colorize: '
                                                       YYYY
                                                 RRRRRYYYYYYYBBBBC
                                              PPRRRRRYYYYYYYYBBBBBCCC
                                             PPRRRRRRYYYYYYYYYBBBBBCCC
                                            PPPRRRRRRYYYYYYYYYBBBBBCCCC
                                            PPPRRRRRRYYYYYYYYYBBBBBCCCC
                                            PPPRRRRRRYYYYYYYYBBBBBBCCCC
                                            PPPPRRRRRYYYYYYYYBBBBBBCCCC
                                             PPPRRRRRRYYYYYYYBBBBBCCCC
                                              PPPRRRRRYYYYYYYBBBBBCCC
                                               PPPRRRRYYYYYYBBBBBCCC
                                                PPPRRRRYYYYYBBBBCCC
                                                 PPPRRRYYYYYBBBCC
                                                   PPRRYYYYBBBCC
                                                    PPRRYYYBBC
                                                     PRRYYYBC

                                                       B B B
                             BBB  BBB                  B B B
                        BBB  BBB  BBB  BBB
                         BBBBBBBBBBBBBBBB
     BBB  BBB             BBBBBBBBBBBBBB             BBB  BBB
BBB  BBB  BBB  BBB         BBBBBBBBBBBB         BBB  BBB  BBB  BBB
 BBBBBBBBBBBBBBBB          BBBBBBBBBBBB          BBBBBBBBBBBBBBBB
  BBBBBBBBBBBBBB           BBBBBBBBBBBB           BBBBBBBBBBBBBB
   BBBBBBBBBBBB  BBB  BBB  BBBBBBBBBBBB  BBB  BBB  BBBBBBBBBBBB
   BBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBB
   BBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBB
   BBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBB
   BBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBB
   BBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBB
   BBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBB
  BBBBBBBBBBBBBBBBBBBBBBBBBBBB      BBBBBBBBBBBBBBBBBBBBBBBBBBBB
  BBBBBBBBBBBBBBBBBBBBBBBBBB          BBBBBBBBBBBBBBBBBBBBBBBBBB
 BBBBBBBBBBBBBBBBBBBBBBBBBBB          BBBBBBBBBBBBBBBBBBBBBBBBBBB
BBBBBBBBBBBBBBBBBBBBBBBBBBBB          BBBBBBBBBBBBBBBBBBBBBBBBBBBB
BBBBBBBBBBBBBBBBBBBBBBBBBBBB          BBBBBBBBBBBBBBBBBBBBBBBBBBBB
BBBBBBBBBBBBBBBBBBBBBBBBBBBB          BBBBBBBBBBBBBBBBBBBBBBBBBBBB
' withUnixLineEndings! !
